//
// C++ Implementation: modelaenlichkeitstabelle
//
// Description:
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "modelaenlichkeits3dview.h"
#include <QStandardItemModel>
#include <QtDebug>
#include <QLayout>

ModelAenlichkeits3dView::ModelAenlichkeits3dView()
 : ModelClient()
{
	table = new Balken3dDiagram(this);
	QGridLayout *l = new QGridLayout(this);
	l->addWidget( table,0,0);
}


ModelAenlichkeits3dView::~ModelAenlichkeits3dView()
{
}


void ModelAenlichkeits3dView::setSpalten( const QVector<int> &s)
{
	Spalten=s;
	updateDiagram();
}

void ModelAenlichkeits3dView::setModel(QStandardItemModel *m)
{
	if(_model) disconnect(_model,SIGNAL(dataChanged( const QModelIndex &, const QModelIndex & )),this,SLOT(updateDiagram()));
	_model = m;
	connect(_model,SIGNAL(dataChanged( const QModelIndex &, const QModelIndex &)),this,SLOT(updateDiagram()));
	updateDiagram();
}

void ModelAenlichkeits3dView::updateDiagram()
{
	if(!_model || Spalten.size()==0) return;

	int rows = _model->rowCount();
	table->setRowCount(rows);
	table->setColumnCount(rows);
	
	// Werte berechnen
	using namespace std;

	map<QString, int>he;
	for(int i=0;i<_model->rowCount();++i)
	{
		for(int j=0; j<_model->rowCount();++j)
		{
			int v=0;
			for(QVector<int>::iterator it=Spalten.begin();it!=Spalten.end();++it)
			{
				QVariant p1 = _model->data(_model->index(i,*it));
				QVariant p2 = _model->data(_model->index(j,*it));

				if(p1 == p2) v++;
			}
			table->setData(i, j, v);
		}
	}
	table->updateGL();
}
