//
// C++ Implementation: test
//
// Description:
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "modelmultidiagramadapter.h"
#include "diagram.h"
#include <QLayout>
#include <QStandardItemModel>
#include <QtDebug>
#include <QMenu>

ModelMultiDiagramAdapter::ModelMultiDiagramAdapter(QWidget *parent)
	:ModelClient(parent),td(0)
{
	setMinimumSize(150,120);
	layout = new QGridLayout(this);
	layout->setMargin(0);
	layout->setSpacing(0);
}

void ModelMultiDiagramAdapter::setModel(QStandardItemModel *m)
{
	if(_model) disconnect(_model,SIGNAL(dataChanged( const QModelIndex &, const QModelIndex & )),this,SLOT(updateDiagram()));
	_model = m;
	connect(_model,SIGNAL(dataChanged( const QModelIndex &, const QModelIndex &)),this,SLOT(updateDiagram()));
	updateDiagram();
}

void ModelMultiDiagramAdapter::setDiagram(Diagram *d)
{
	if(td) delete td;
	td = d;
	td->setParent(this);
	layout->addWidget(td,0,0);
	updateDiagram();
}

void ModelMultiDiagramAdapter::setSpalten(const QVector<int> &s)
{
	Spalten = s;
	updateDiagram();
}

void ModelMultiDiagramAdapter::setTitle(const QString &t)
{
	_title = t;
	if(td) td->setTitle( t );
}

Diagram *ModelMultiDiagramAdapter::diagram()
{
	return td;
}

QStandardItemModel *ModelMultiDiagramAdapter::model()
{
	return _model;
}

QVector<QAction*> ModelMultiDiagramAdapter::actionList()
 {
	 return actions;
 }

void ModelMultiDiagramAdapter::contextMenuEvent ( QContextMenuEvent * event )
{
	QMenu m;
	m.addActions(actions.toList());
	m.addSeparator();
	m.addActions(diagram()->actionList().toList());
	m.exec(event->globalPos());
}

void ModelMultiDiagramAdapter::saveData(QDataStream& s,int ver)
{
	td->saveData(s,ver);
}

void ModelMultiDiagramAdapter::loadData(QDataStream& s,int ver)
{
	td->loadData(s,ver);
}
