//
// C++ Implementation: tabelle1
//
// Description: 
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "tabelle1.h"

#include <QTableView>
#include <QLayout>
#include <QLabel>
#include <QStandardItemModel>

Tabelle1::Tabelle1(QWidget *parent)
	:ModelClient(parent)
{
	tab = new QTableView(this);
	tab->setAlternatingRowColors(true);
	tab->setSelectionBehavior(QAbstractItemView::SelectColumns);
	tab->setEditTriggers(QAbstractItemView::NoEditTriggers); // Read Only
	QGridLayout *l = new QGridLayout(this);
	QLabel *l1 = new QLabel("Datentabelle",this);
	l1->setAlignment( Qt::AlignCenter );
	l->setMargin( 0 );
	l->setSpacing( 1 );
	l->addWidget(l1,0,0);
	l->addWidget(tab,1,0);
	setMinimumSize( 500,300 );
}

void Tabelle1::setModel(QStandardItemModel *m)
{
	_model = m;
	tab->setModel(_model);
}


/*!
    \fn Tabelle1::table()
 */
QTableView* Tabelle1::table()
{
	return tab;
}


/*!
    \fn Tabelle1::hideSelectedColumns()
 */
void Tabelle1::hideSelectedColumns()
{
	QItemSelectionModel *sm = tab->selectionModel();
	QModelIndexList cols = sm->selectedColumns();
	for(int i=0;i<cols.count();++i)
	{
		hiddenColumns << cols[i].column();
		tab->setColumnHidden(cols[i].column(),true);
	}
}
