//
// C++ Implementation: viewdiagramview
//
// Description: 
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "vierdiagramview.h"
#include "tortendiagram.h"
#include "haeufigkeitsdiagramadapter.h"
#include <QLayout>

VierDiagramView::VierDiagramView(QWidget* parent): ModelClient(parent),t1(0),t2(0),t3(0),t4(0)
{
	layout = new QGridLayout(this);
	layout->setMargin(0);
	layout->setSpacing(0);
}


VierDiagramView::~VierDiagramView()
{
}

void VierDiagramView::setModel(QStandardItemModel* m)
{
	_model = m;
	if(t1) t1->setModel(m);
	if(t2) t2->setModel(m);
	if(t3) t3->setModel(m);
	if(t4) t4->setModel(m);
}

void VierDiagramView::setClient(ModelClient *c,int pos)
{
	switch(pos)
	{
		case 0:
			if(t1) delete t1;
			t1 = c;
			layout->addWidget(t1,0,0);
			t1->setModel(_model);
			break;
		case 1:
			if(t2) delete t2;
			t2 = c;
			layout->addWidget(t2,0,1);
			t2->setModel(_model);
			break;
		case 2:
			if(t3) delete t3;
			t3 = c;
			layout->addWidget(t3,1,0);
			t3->setModel(_model);
			break;
		case 3:
			if(t4) delete t4;
			t4 = c;
			layout->addWidget(t4,1,1);
			t4->setModel(_model);
			break;
		default:
			break;
	}
}
