#ifndef _VIEW_
#define _VIEW_

#include <QMainWindow>
#include <QStandardItemModel>
#include <QQueue>
class QStackedWidget;
class QComboBox;
class Tabelle1;
class ModelClient;
class QTextEdit;
class QListView;
class QAction;
class QUndoStack;

class View : public QMainWindow
{
	Q_OBJECT
	public:
	View(QWidget *parent=0);
	virtual ~View();
	
	void load(const QString& filename);
	void save(const QString& filename);
    	void removeView(int i);
	void removeView(ModelClient *w);
	ModelClient *createView(const QString& adapter,const QString & diagram,const QVector<int>& spalten,const QString& title,const QString &text=QString());
	void moveView(int i,int j);
	int viewIndex(ModelClient*m);
	
	protected:
	QStandardItemModel *model,*vmodel;
	QStackedWidget *sw;
	QTextEdit *tText;
	QComboBox *cb;
	QStringList ColType;
	Tabelle1 *tab;
	int curIdx;
	QStringList Diagramme,Adapter,MultiAdapter,DiagramOnly;
	QListView *vList;
	QUndoStack *undoStack;
	QString _filename;
	
	// Actions
	QAction *aImportSM,*aImportCSV,*aImportViews,*aExport,*aExportViews,*aOpen,*aSave,*aSaveAs,*aExit,*aCopy;
	QAction *aCreateView,*aRemoveView,*aHideColumns,*aClearViews,*aRenameColumn,*aReplaceInColumn,*aNew,*aHome;
	QAction *aCombineColumn,*aWeightColumn,*aNormColumn,*aNumColumn,*aStatColumn,*aGotoColumn,*aLinReg,*aCopyColumns;

	protected slots:
    	void removeCurrentView();
	void createSelectedView();
	void createViews();
	void createViewsSM();
	void createDemoViews();
	void widgetChanged(int idx);
	void clipCopyView();
	void vListActivated(const QModelIndex & index);
	void dataRenameColumn();
	void dataReplaceColumns();
	void dataCombineColumns();
	void dataWeightColumns();
	void clearViews();
	void exportFile();
	void exportViewsFile();
	void importViewsFile();
	void importFile();
	void importSMFile();
	void dataNormalizeColumn();
	void dataNumericColumns();
	void dataStatColumns();
	void modelSelectionChanged();
	void hideSelectedColumns();
	void loadFile();
	void saveFile();
	void saveFileAs();
	void viewGotoColumn();
	void dataLinReg();
	void vListContextMenu(const QPoint& pos);
	
	protected:
	QStandardItem * appendView(const QString &title,ModelClient *view);
	void exportCSV(const QString &filename);
	void importCSV(const QString& filename);
	void importSM(const QString &filename);
	void exportViewsCSV(const QString&filename);
	void importViewsCSV(const QString &filename);

protected slots:
    void dataCopyColumns();
    void goHome();
};

#endif
